	*=$8000		; set start




native_brk_handler = $1000
native_cop_handler = $1004
emulation_brk_handler = $1008
emulation_cop_handler = $100C

	*= $0
 .rs $10
test_num: .word 0
result_a: .word 0
result_x: .word 0
result_y: .word 0
result_p: .word 0
result_s: .word 0
result_d: .word 0
result_dbr: .byte 0
retaddr: .word 0  ; return address from bankN_save_results
vblank_counter: .byte 0  ; wait for vblank when it reaches 0

;.segment "CODE"

	*= $8000
main:
 
 	CLC
	xce
	sei
;	jsr UART_Init
	rep #$18  ; 16 bit X/Y
	sep #$20  ; 8 bit A
	ldx !#$01EF
	txs
	jsr init
	ldx !#$ffff
	stx test_num
	jmp start_tests

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

init:
	jsr init_mem
	ldx !#txt_running
	jsr write_text
	ldx !#txt_testnum
	jsr write_text

	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

init_mem:
	; Put STP opcodes in some places in case of errant jumps or software interrupts
	lda #$DB
	; BRK/COP handlers
	sta $1000
	sta $1004
	sta $1008
	sta $100C
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; 0:x = text (null-terminated).  y = vmem word address
; IO page $007Fxx

write_text:
.loop
	lda $00,x
	beq .fin
	jsr chrout
	inx
	bra .loop
.fin
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; a = val.
write_hex8:
	pha
	lsr 
	lsr 
	lsr 
	lsr 
	clc
	jsr write_digit
	pla
	and #$0F
write_digit:  ; write hex digit in A
	cmp #$0A
	bcc num
	clc
	adc #'A'-$0A-'0'
num:
	clc
	adc #'0'
	jsr chrout
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
write_crlf:
	LDA #$0d
	jsr chrout
	LDA #$0a
	jmp chrout

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 0:x = address. y = vmem word address
write_hex16:
	lda $01,x
	jsr write_hex8
	lda $00,x
	jmp write_hex8

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; x = new test num
init_test:
	; Check that we haven't skipped a test
	dex
	cpx test_num
	beq .ok

	; ** Invalid test order - possibly an errant jump **
	clc
	xce
	sei
	rep #$18  ; 16 bit X/Y
	sep #$20  ; 8 bit A
	ldx !#$01EF
	txs

	jsr update_test_num
	ldx !#txt_fail
	jsr write_text
	ldx !#txt_skipped
	jsr write_text
	jmp *
	
.ok
	inx
	stx test_num
	JSR update_test_num
;	jsr write_crlf
	rtl

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Save the register values, and reset state (D, DBR, etc.)
save_results:
	; p register was already saved, and emulation mode was cleared.
	sei
	rep #$38
;	.a16
;	.i16
	phd
	pha
	lda !#$0000
	tcd
	pla
	sta result_a
	stx result_x
	sty result_y
	plx  ; d register
	stx result_d
	tsc  ; original S value minus 3 (due to jsl).
	inc 
	inc 
	inc 
	sta result_s

	sep #$20
;	.a8
	phb
	pla
	sta result_dbr
	lda #$00
	pha
	plb
	rtl

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

success:
;	jsr update_test_num
	
	ldx !#txt_success
	jsr write_text

	jmp *

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

update_test_num:
	ldx !#test_num
	jmp write_hex16


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

fail:
	ldx !#$1ef
	txs  ; in case s is invalid
;	jsr update_test_num

	LDX !#txt_fail
	jsr write_text
	ldx !#txt_a
	jsr write_text
	ldx !#result_a
	jsr write_hex16

	LDX !#txt_x
	jsr write_text
	ldx !#result_x
	jsr write_hex16

	LDX !#txt_y
	jsr write_text
	ldx !#result_y
	jsr write_hex16

	LDX !#txt_p
	jsr write_text
	lda result_p
	jsr write_hex8

	LDX !#txt_s
	jsr write_text
	ldx !#result_s
	jsr write_hex16
	jsr write_crlf

	JSR wait_for_key

	jsr init

	; jump to next test

	rep #$20
;	.a16
	lda test_num
	inc 
	asl   
	asl   ; A = (test_num+1) * 4
	tax
	sep #$20
;	.a8
	ldy \2tests_table,x   ; y = test offset
	lda \2tests_table+2,x ; a = test bank
	pha
	dey  ; the return address should be 1 less than the target
	phy
	rtl  ; actually a jump to the next test

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
test_passed:
	ldx !#txt_passed
	jsr write_text
	rtl

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
wait_for_key:
	ldx !#txt_press
	jsr write_text
	jmp getchr

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	.include "io.asm"
 
	.include "tests-full.inc"

	*= $d000
txt_running: .byte "Running tests...", $0a, $0d, 0
txt_success: .byte "Success", $0d, $0a, 0
txt_fail: .byte " Failed", $0a, $0d, 0
txt_passed: .byte " Passed", $0a, $0d, 0
txt_skipped: .byte "Invalid test order", $0d, $0a, 0
txt_testnum: .byte "Test number:", $0a, $0d, 0
txt_press: .byte  $0d, $0a,"Press key for next test...", $0d, $0a, 0
txt_a: .byte  $0d, $0a," A = ", 0
txt_x: .byte  $0d, $0a," X = ", 0
txt_y: .byte  $0d, $0a," Y = ", 0
txt_p: .byte  $0d, $0a," P = ", 0
txt_s: .byte  $0d, $0a," S = ", 0
zero:
	.byte 0, 0

tests_table:  ; used for failed test skipping
	.include "tests_table.inc"
	.dword success

;  "TEST_DATA"  ; At address FFA0. Used by some tests
	*= $FFA0
	.word $1212
	.word $8000
	.word $8000
	.byte $06

	*= $FFE0
	.word 0, 0, native_cop_handler, native_brk_handler, 0, 0, 0, 0
	.word 0, 0, emulation_cop_handler, 0, 0, 0, main, emulation_brk_handler
